package it.micegroup.gestioneferie.pianificazioneferie.service;

import java.util.Map;
import java.util.List;
import java.util.Locale;
import java.util.HashMap;
import java.util.Optional;
import java.util.ArrayList;
import java.util.Collection;
import java.util.ResourceBundle;

import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.domain.Specification;

import org.springframework.context.i18n.LocaleContextHolder;

import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import net.sf.jasperreports.engine.JRParameter;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.engine.JasperReport;
import net.sf.jasperreports.engine.JasperFillManager;
import net.sf.jasperreports.engine.JasperExportManager;
import net.sf.jasperreports.engine.data.JRBeanCollectionDataSource;

import it.micegroup.gestioneferie.pianificazioneferie.entity.DmotivazioniAlertPf;

import it.micegroup.gestioneferie.pianificazioneferie.entity.DmotivazioniAlertPfKey;

import it.micegroup.gestioneferie.pianificazioneferie.entity.DmotivazioniAlertPf_;
import it.micegroup.gestioneferie.pianificazioneferie.criteria.DmotivazioniAlertPfCriteria;
import it.micegroup.gestioneferie.pianificazioneferie.repository.DmotivazioniAlertPfRepository;
import it.micegroup.voila2runtime.specification.FilterService;

import it.micegroup.gestioneferie.pianificazioneferie.entity.DmotivazioniAlertPf_;
import it.micegroup.gestioneferie.pianificazioneferie.entity.DmotivazioniAlertPfKey_;
import lombok.RequiredArgsConstructor;
import it.micegroup.gestioneferie.libs.service.BaseServiceImpl;
import it.micegroup.gestioneferie.pianificazioneferie.entity.DmotivazioniAlertPfKey_;

import java.util.stream.Collectors;
import it.micegroup.gestioneferie.pianificazioneferie.entity.DammtiPianiFerie;
import it.micegroup.voila2runtime.entity.GenericEntity;
import it.micegroup.voila2runtime.exception.BusinessException;
import net.sf.jasperreports.engine.JRException;

@RequiredArgsConstructor
@Service
@Transactional
public class DmotivazioniAlertPfServiceImpl extends BaseServiceImpl implements DmotivazioniAlertPfService {

	private final DmotivazioniAlertPfRepository dmotivazioniAlertPfRepository;
	private final FilterService<DmotivazioniAlertPf> filterService;

	// CHILD SERVICES
	private final DammtiPianiFerieService dammtiPianiFerieService;

	@SuppressWarnings("unused")
	private static final Logger LOGGER = LogManager.getLogger(DmotivazioniAlertPfServiceImpl.class);

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * findAll(org. springframework.data.domain.Pageable)
	 */
	@Override
	@Transactional(readOnly = true)
	public Page<DmotivazioniAlertPf> findAll(Pageable pageable) {
		return dmotivazioniAlertPfRepository.findAll(pageable);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * findAll()
	 */
	@Override
	@Transactional(readOnly = true)
	public List<DmotivazioniAlertPf> findAll() {
		return dmotivazioniAlertPfRepository.findAll();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * findByCriteria(java. lang.Object, org.springframework.data.domain.Pageable)
	 */
	@Override
	@Transactional(readOnly = true)
	public Page<DmotivazioniAlertPf> findByCriteria(DmotivazioniAlertPfCriteria criteria, Pageable pageable) {
		final Specification<DmotivazioniAlertPf> specification = createSpecification(criteria);
		return dmotivazioniAlertPfRepository.findAll(specification, pageable);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * findByCriteria(java. lang.Object)
	 */
	@Override
	@Transactional(readOnly = true)
	public List<DmotivazioniAlertPf> findByCriteria(DmotivazioniAlertPfCriteria criteria) {
		final Specification<DmotivazioniAlertPf> specification = createSpecification(criteria);
		return dmotivazioniAlertPfRepository.findAll(specification);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * findById(java.lang. Object)
	 */
	@Override
	@Transactional(readOnly = true)
	public Optional<DmotivazioniAlertPf> findById(DmotivazioniAlertPfKey id) {
		return dmotivazioniAlertPfRepository.findByDmotivazioniAlertPfKey(id);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * exists(java.lang. Object)
	 */
	@Override
	public boolean exists(DmotivazioniAlertPfKey id) {
		return dmotivazioniAlertPfRepository.existsById(id);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * insert(java. lang.Object)
	 */
	@Override
	public DmotivazioniAlertPf insert(@Valid DmotivazioniAlertPf entity) {
		return dmotivazioniAlertPfRepository.save(entity);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * update(java. lang.Object)
	 */
	@Override
	public DmotivazioniAlertPf update(@Valid DmotivazioniAlertPf entity) {
		return dmotivazioniAlertPfRepository.save(entity);
	}

	@Override
	public void delete(DmotivazioniAlertPf entity) {
		dmotivazioniAlertPfRepository.delete(entity);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * deleteById(java.lang. Object)
	 */
	@Override
	public void deleteById(DmotivazioniAlertPfKey id) {
		dmotivazioniAlertPfRepository.deleteById(id);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * deleteByIdIn(java.lang. Object)
	 */
	@Override
	public void deleteByIdIn(Collection<DmotivazioniAlertPfKey> ids) {
		dmotivazioniAlertPfRepository.deleteByIdIn(ids);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * it.micegroup.gestioneferie.pianificazioneferie.service.GenericEntityService#
	 * findByObjectKey(java.lang.String)
	 */
	@Override
	@Transactional(readOnly = true)
	public Optional<DmotivazioniAlertPf> findByObjectKey(String id) {
		DmotivazioniAlertPf dmotivazioniAlertPf = new DmotivazioniAlertPf(id);

		return findById(dmotivazioniAlertPf.getDmotivazioniAlertPfKey());
	}

	/**
	 * Convert DmotivazioniAlertPfCriteria to a {@link Specification}
	 * 
	 * @param criteria
	 * @return
	 */
	private Specification<DmotivazioniAlertPf> createSpecification(DmotivazioniAlertPfCriteria criteria) {
		Specification<DmotivazioniAlertPf> specification = Specification.where(null);

		if (criteria != null) {
			// Attribute filters
			if (criteria.getSequIdMotivazioneAlertPf() != null) {
				specification = specification.and(filterService.generateRangeSpecification(
						criteria.getSequIdMotivazioneAlertPf(), DmotivazioniAlertPf_.sequIdMotivazioneAlertPf));
			}
			if (criteria.getCodiMotivazioneAlert() != null) {
				specification = specification.and(filterService.generateStringSpecification(
						criteria.getCodiMotivazioneAlert(), DmotivazioniAlertPf_.codiMotivazioneAlert));
			}
			if (criteria.getDescMotivazioneAlert() != null) {
				specification = specification.and(filterService.generateStringSpecification(
						criteria.getDescMotivazioneAlert(), DmotivazioniAlertPf_.descMotivazioneAlert));
			}
			if (criteria.getDataUltimaModifica() != null) {
				specification = specification.and(filterService.generateRangeSpecification(
						criteria.getDataUltimaModifica(), DmotivazioniAlertPf_.dataUltimaModifica));
			}
			if (criteria.getFlagEliminato() != null) {
				specification = specification.and(filterService.generateStringSpecification(criteria.getFlagEliminato(),
						DmotivazioniAlertPf_.flagEliminato));
			}
			if (criteria.getDataFineRecord() != null) {
				specification = specification.and(filterService.generateRangeSpecification(criteria.getDataFineRecord(),
						DmotivazioniAlertPf_.dataFineRecord));
			}
			if (criteria.getUtenteUltimaModifica() != null) {
				specification = specification.and(filterService.generateStringSpecification(
						criteria.getUtenteUltimaModifica(), DmotivazioniAlertPf_.utenteUltimaModifica));
			}
			if (criteria.getDataInizioRecord() != null) {
				specification = specification.and(filterService.generateRangeSpecification(
						criteria.getDataInizioRecord(), DmotivazioniAlertPf_.dataInizioRecord));
			}

			// CompositeKey Filters

		}
		return specification;
	}

	@Override
	@Transactional()
	public DmotivazioniAlertPf bulkUpdate(DmotivazioniAlertPf dmotivazioniAlertPf) {
		List<DammtiPianiFerie> updateTheDammtiPianiFerie = dmotivazioniAlertPf.getTheDammtiPianiFerie().stream()
				.filter(child -> !child.isDeletedEntityState()).collect(Collectors.toList());
		List<DammtiPianiFerie> deleteTheDammtiPianiFerie = dmotivazioniAlertPf.getTheDammtiPianiFerie().stream()
				.filter(GenericEntity::isDeletedEntityState).collect(Collectors.toList());

		dmotivazioniAlertPf.setTheDammtiPianiFerie(updateTheDammtiPianiFerie);

		DmotivazioniAlertPf update = this.update(dmotivazioniAlertPf);

		deleteTheDammtiPianiFerie.forEach(child -> dammtiPianiFerieService.deleteById(child.getDammtiPianiFerieKey()));
		return update;
	}
}
